fs = require 'fs'
connect = require 'connect'
express = require 'express'
jade = require 'jade'
color = require('ansi-color').set
yaml = require 'yaml'

app = module.exports = express.createServer()

# CONFIGURATION

config = yaml.eval(
        fs .readFileSync(__dirname+'/config.yaml')
           .toString('utf-8')
        );


app.configure(() ->
	app.set 'view engine', 'jade'
	app.set 'views', "#{__dirname}/views"

	app.use connect.bodyParser()
	app.use connect.static(__dirname + '/public')
	app.use express.cookieParser()
	app.use express.session({secret : "shhhhhhhhhhhhhh!"})
	app.use express.logger()
	app.use express.methodOverride()
	app.use app.router
)

app.configure 'development', () ->
	app.use express.errorHandler({
		dumpExceptions: true
		showStack     : true
	})

app.configure 'production', () ->
	app.use express.errorHandler()

# ROUTES

app.get '/', (req, res) ->
	res.render 'layout',
		locals:
			title: 'Hello World!'

# SERVER

app.listen config.server.port
console.log color "Express server listening on port #{app.address().port}", 'green'
